[Setup]
AppName=Ext2Fsd
AppVerName=Ext2Fsd 0.62
AppPublisher=Matt Wu
AppPublisherURL=http://www.ext2fsd.com
AppSupportURL=http://www.ext2fsd.com
AppUpdatesURL=http://www.ext2fsd.com
DefaultDirName={pf}\Ext2Fsd
DefaultGroupName=Ext2Fsd
AllowNoIcons=true
OutputDir=C:\works\Ext2Fsd\0.62
OutputBaseFilename=Ext2Fsd-0.62
Compression=lzma
SolidCompression=true
InternalCompressLevel=max
SourceDir=C:\works\Ext2Fsd\0.62\Ext2Fsd
VersionInfoVersion=1.38.08.06
VersionInfoCompany=Ext2Fsd Group
AllowUNCPath=false
DisableReadyPage=true
ShowLanguageDialog=auto
MinVersion=0,5.0.2195
AppVersion=0.62
VersionInfoDescription=Installer for Ext2Fsd 0.62
UninstallRestartComputer=true
Uninstallable=true
ArchitecturesInstallIn64BitMode=x64


[Files]
Source: Documents\*; DestDir: {app}\Documents; Flags: ignoreversion; Components: driver
Source: Setup\mke2fs.exe; DestDir: {app}; Flags: ignoreversion; Components: driver
Source: Setup\e2fsck.exe; DestDir: {app}; Flags: ignoreversion; Components: driver
Source: Setup\tune2fs.exe; DestDir: {app}; Flags: ignoreversion; Components: driver
Source: Setup\debugfs.exe; DestDir: {app}; Flags: ignoreversion; Components: driver
Source: Setup\cyggcc_s-1.dll; DestDir: {app}; Flags: ignoreversion; Components: driver
Source: Setup\cygwin1.dll; DestDir: {app}; Flags: ignoreversion; Components: driver
Source: Setup\Ext2Mgr.exe; DestDir: {app}; Flags: ignoreversion; Components: driver
Source: Setup\Mount.exe; DestDir: {app}; Flags: ignoreversion; Components: driver
Source: Setup\DrvRemover.exe; DestDir: {app}; Flags: ignoreversion; Components: driver
Source: Setup\w2k\i386\ext2fsd.sys; DestDir: {sys}\Drivers; Components: driver; Check: not Is64BitInstallMode; MinVersion: 0,5.0.2195; OnlyBelowVersion: 0,5.01.2500; Flags: restartreplace ignoreversion uninsrestartdelete promptifolder
Source: Setup\wxp\i386\ext2fsd.sys; DestDir: {sys}\Drivers; Components: driver; Check: not Is64BitInstallMode; MinVersion: 0,5.01.2600; Flags: restartreplace ignoreversion uninsrestartdelete promptifolder
Source: Setup\wxp\amd64\ext2fsd.sys; DestDir: {sys}\Drivers; Components: driver; Check: Is64BitInstallMode; MinVersion: 0,5.01.2600; Flags: restartreplace ignoreversion uninsrestartdelete promptifolder

[Icons]
Name: {group}\Ext2 Volume Manager; Filename: {app}\Ext2Mgr.exe; WorkingDir: {app}
Name: {group}\Documents\Frequently Asked Questions; Filename: {app}\Documents\FAQ.txt; WorkingDir: {app}\Documents
Name: {group}\Documents\Release Notes; Filename: {app}\Documents\notes.txt; WorkingDir: {app}\Documents
Name: {group}\Documents\Read Me; Filename: {app}\Documents\readme.txt; WorkingDir: {app}\Documents
Name: {group}\Uninstall Ext2Fsd; Filename: "{uninstallexe}"; WorkingDir: {app}

[Run]
Filename: {app}\Ext2Mgr.exe; Description: Start Ext2 Volume Manager right now to assign driver letters for your ext2/ext3 partitions ?; Flags: runascurrentuser nowait postinstall skipifsilent; WorkingDir: {app}

[UninstallRun]

[Types]
Name: custom; Description: Ext2 File System Driver; Flags: iscustom

[Components]
Name: driver; Description: Ext2 File System Driver; ExtraDiskSpaceRequired: 1177; Flags: fixed; Types: custom

[Tasks]
Name: auto_start; Description: Make Ext2Fsd automatically started when system boots; Flags: checkablealone
Name: write; Description: Enable write support for Ext2 partitions; Flags: checkablealone
Name: write\ext3_write; Description: Enable force writing support on Ext3 partitions; Flags: dontinheritcheck

[Registry]
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd; ValueType: string; ValueName: DisplayName; ValueData: Linux ext2 File system driver; Flags: uninsdeletekey
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd; ValueType: dword; ValueName: ErrorControl; ValueData: 00000001; Flags: uninsdeletekey
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd; ValueType: string; ValueName: Group; ValueData: File System; Flags: uninsdeletekey
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd; ValueType: dword; ValueName: Start; ValueData: 00000001; Flags: uninsdeletekey; Tasks: auto_start
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd; ValueType: dword; ValueName: Start; ValueData: 00000003; Flags: uninsdeletekey; Tasks: not auto_start
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd; ValueType: dword; ValueName: Type; ValueData: 00000001; Flags: uninsdeletekey
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd\Parameters; ValueType: dword; ValueName: AutoMount; ValueData: 00000001; Flags: uninsdeletekey;
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd\Parameters; ValueType: dword; ValueName: WritingSupport; ValueData: 00000000; Flags: uninsdeletekey; Tasks: not write
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd\Parameters; ValueType: dword; ValueName: WritingSupport; ValueData: 00000001; Flags: uninsdeletekey; Tasks: write
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd\Parameters; ValueType: dword; ValueName: CheckingBitmap; ValueData: 00000000; Flags: uninsdeletekey
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd\Parameters; ValueType: dword; ValueName: Ext3ForceWriting; ValueData: 00000000; Flags: uninsdeletekey; Tasks: not write\ext3_write
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd\Parameters; ValueType: dword; ValueName: Ext3ForceWriting; ValueData: 00000001; Flags: uninsdeletekey; Tasks:  write\ext3_write
Root: HKLM; SubKey: SYSTEM\CurrentControlSet\Services\Ext2Fsd\Parameters; ValueType: string; ValueName: CodePage; ValueData: utf8; Flags: uninsdeletekey

[Code]

type
	SERVICE_STATUS = record
    	dwServiceType				: cardinal;
    	dwCurrentState				: cardinal;
    	dwControlsAccepted			: cardinal;
    	dwWin32ExitCode				: cardinal;
    	dwServiceSpecificExitCode	: cardinal;
    	dwCheckPoint				: cardinal;
    	dwWaitHint					: cardinal;
	end;

	ENUM_SERVICE_STATUS = record
		strServiceName:PAnsiChar;
		strDisplayName:PAnsiChar;
		Status:			SERVICE_STATUS;
	end;
	HANDLE = cardinal;
const
	ENUM_SERVICE_STATUS_SIZE   = 36;

const SERVICE_ERROR_NORMAL		=1;
const
	SERVICE_QUERY_CONFIG		= $1;
	SERVICE_CHANGE_CONFIG		= $2;
	SERVICE_QUERY_STATUS		= $4;
	SERVICE_START				= $10;
	SERVICE_STOP				= $20;
	SERVICE_ALL_ACCESS			= $f01ff;
	SC_MANAGER_ALL_ACCESS		= $f003f;
	SERVICE_KERNEL_DRIVER		=$1;
	SERVICE_FILE_SYSTEM_DRIVER	= $2;
	SERVICE_WIN32_OWN_PROCESS	= $10;
	SERVICE_WIN32_SHARE_PROCESS	= $20;
	SERVICE_WIN32				= $30;
	SERVICE_INTERACTIVE_PROCESS = $100;
	SERVICE_BOOT_START          = $0;
	SERVICE_SYSTEM_START        = $1;
	SERVICE_AUTO_START          = $2;
	SERVICE_DEMAND_START        = $3;
	SERVICE_DISABLED            = $4;
	SERVICE_DELETE              = $10000;
	SERVICE_CONTROL_STOP		= $1;
	SERVICE_CONTROL_PAUSE		= $2;
	SERVICE_CONTROL_CONTINUE	= $3;
	SERVICE_CONTROL_INTERROGATE = $4;
	SERVICE_STOPPED				= $1;
	SERVICE_START_PENDING       = $2;
	SERVICE_STOP_PENDING        = $3;
	SERVICE_RUNNING             = $4;
	SERVICE_CONTINUE_PENDING    = $5;
	SERVICE_PAUSE_PENDING       = $6;
	SERVICE_PAUSED              = $7;
	SERVICE_NO_CHANGE            =  $ffffffff;

function ControlService(hService :HANDLE; dwControl :cardinal;var ServiceStatus :SERVICE_STATUS) : boolean;
external 'ControlService@advapi32.dll stdcall';

function CloseServiceHandle(hSCObject :HANDLE): boolean;
external 'CloseServiceHandle@advapi32.dll stdcall';

function DeleteService(hService :HANDLE): boolean;
external 'DeleteService@advapi32.dll stdcall';

function CreateService(hSCManager :HANDLE;lpServiceName, lpDisplayName: string;dwDesiredAccess,dwServiceType,dwStartType,dwErrorControl: cardinal;lpBinaryPathName,lpLoadOrderGroup: String; lpdwTagId : cardinal;lpDependencies,lpServiceStartName,lpPassword :string): cardinal;
external 'CreateServiceA@advapi32.dll stdcall';

function OpenService(hSCManager :HANDLE;lpServiceName: string; dwDesiredAccess :cardinal): HANDLE;
external 'OpenServiceA@advapi32.dll stdcall';

function OpenSCManager(lpMachineName, lpDatabaseName: string; dwDesiredAccess :cardinal): HANDLE;
external 'OpenSCManagerA@advapi32.dll stdcall';

function QueryServiceStatus(hService :HANDLE;var ServiceStatus :SERVICE_STATUS) : boolean;
external 'QueryServiceStatus@advapi32.dll stdcall';

function ChangeServiceConfig(hService:HANDLE;dwServiceType,dwStartType,dwErrorControl:cardinal;lpBinaryPathName,lpLoadOrderGroup: String;lpdwTagId : cardinal;lpDependencies,lpServiceStartName,lpPassword ,lpDisName:string):boolean;
external 'ChangeServiceConfigA@advapi32.dll stdcall';

function StartService(hService:HANDLE;nNumOfpara:DWORD;strParam:String):boolean;
external 'StartServiceA@advapi32.dll stdcall';

function EnumDependentServices(hService:HANDLE;dwServiceState:DWORD;var Service_Status : Array of ENUM_SERVICE_STATUS; cbBufSize:DWORD; var pcbByteNeeded, lpServicesReturned:DWORD):boolean;
external 'EnumDependentServicesA@advapi32.dll stdcall';

function GetLastError():DWORD;
external 'GetLastError@Kernel32.dll stdcall';



function OpenServiceManager() : HANDLE;
begin
	if UsingWinNT() = true then begin
		Result := OpenSCManager('','ServicesActive',SC_MANAGER_ALL_ACCESS);
		if Result = 0 then
			MsgBox('the servicemanager is not available', mbError, MB_OK)
	end
	else begin
			MsgBox('only nt based systems support services', mbError, MB_OK)
			Result := 0;
	end
end;

function IsServiceInstalled(ServiceName: string) : boolean;
var
	hSCM	: HANDLE;
	hService: HANDLE;
begin
	hSCM := OpenServiceManager();
	Result := false;
	if hSCM <> 0 then begin
		hService := OpenService(hSCM,ServiceName,SERVICE_QUERY_CONFIG);
        if hService <> 0 then begin
            Result := true;
            CloseServiceHandle(hService)
		end;
        CloseServiceHandle(hSCM)
	end
end;

function IsServiceRunning(ServiceName: string) : boolean;
var
	hSCM	: HANDLE;
	hService: HANDLE;
	Status	: SERVICE_STATUS;
begin
	hSCM := OpenServiceManager();
	Result := false;
	if hSCM <> 0 then begin
		hService := OpenService(hSCM,ServiceName,SERVICE_QUERY_STATUS);
    	if hService <> 0 then begin
			if QueryServiceStatus(hService,Status) then begin
				Result :=(Status.dwCurrentState = SERVICE_RUNNING)
        	end;
            CloseServiceHandle(hService)
		    end;
        CloseServiceHandle(hSCM)
	end
end;

function StopService(ServiceName: string) : boolean;
var
	hSCM	: HANDLE;
	hService: HANDLE;
	Status	: SERVICE_STATUS;
	i 		: integer;
begin
	hSCM := OpenServiceManager();
	Result := false;

	//OutputString('=============Service Name=====:'+ServiceName+' =============================='+#10+#13);
	if hSCM <> 0 then begin
		hService := OpenService(hSCM,ServiceName,SERVICE_STOP);
        if hService <> 0 then begin
        	Result := ControlService(hService,SERVICE_CONTROL_STOP,Status);
            CloseServiceHandle(hService)
		end;
        CloseServiceHandle(hSCM)

        // Ӿ3
        for i:=1 to 3 do
        begin
         if( IsServiceRunning(ServiceName)) then
         begin
			Sleep(3000);
		 end
		 else
		 begin
		  exit;
		 end;
        end;


	end;
end;

function RunService(ServiceName: string) : boolean;
var
	hSCM	: HANDLE;
	hService: HANDLE;
	Status	: SERVICE_STATUS;

begin
	hSCM := OpenServiceManager();
	Result := false;
	if hSCM <> 0 then begin
		hService := OpenService(hSCM,ServiceName,SERVICE_START);
        if hService <> 0 then begin
        	Result := StartService(hService,0,'');
            CloseServiceHandle(hService)
		end;
        CloseServiceHandle(hSCM)


	end;
end;


function RemoveService(ServiceName: string) : boolean;
var
	hSCM	: HANDLE;
	hService: HANDLE;
	Status	: SERVICE_STATUS;

begin
	hSCM := OpenServiceManager();
	Result := false;
	if hSCM <> 0 then begin
		hService := OpenService(hSCM,ServiceName,SERVICE_DELETE);
        if hService <> 0 then begin
        	Result := DeleteService(hService);
            RegDeleteKeyIncludingSubkeys(HKEY_LOCAL_MACHINE,'SYSTEM\CurrentControlSet\Services\'+ServiceName);
            sleep(100);
            RegDeleteKeyIncludingSubkeys(HKEY_LOCAL_MACHINE,'SYSTEM\CurrentControlSet\Services\'+ServiceName);
		end;
        CloseServiceHandle(hSCM)
	end;
end;

function InstallService(FileName, ServiceName, DisplayName, Description : string;ServiceType,StartType :cardinal;szDepends:string) : boolean;
var
	hSCM	: HANDLE;
	hService: HANDLE;
begin
	hSCM := OpenServiceManager();
	Result := false;
	if hSCM <> 0 then begin
		hService := CreateService(hSCM,ServiceName,DisplayName,SERVICE_ALL_ACCESS,ServiceType,StartType,SERVICE_ERROR_NORMAL,FileName,'',0,szDepends,'','');
		if hService <> 0 then begin
			Result := true;
			// Win2K & WinXP supports aditional description text for services
			if Description<> '' then
				RegWriteStringValue(HKLM,'System\CurrentControlSet\Services\' + ServiceName,'Description',Description);
			CloseServiceHandle(hService)
		end;
    CloseServiceHandle(hSCM)
	end
end;

function NeedRestart(): Boolean;
begin
    InstallService(expandconstant('{sys}\Drivers\Ext2Fsd.sys'),'Ext2Fsd','Ext2 File System','Ext2 File System Driver',SERVICE_FILE_SYSTEM_DRIVER, SERVICE_AUTO_START,#0);
    sleep(100);
    result := RunService('Ext2Fsd');
    if (result = false) then begin
        sleep(100);
        result := RunService('Ext2Fsd');
    end;
    if (result = false) then begin
        sleep(100);
        result := RunService('Ext2Fsd');
    end;
    if (result = false) then begin
        result := true;
    end
    else begin
        result := false;
    end
end;

procedure CurStepChanged(CurStep: TSetupStep);
var
  ResultCode: Integer;
  Wnd: HWND;
begin

if (CurStep = ssInstall) then
begin

  Wnd := FindWindowByWindowName('Ext2 Volume Manager');
  if Wnd <> 0 then
    SendMessage(Wnd, $1402, 0, $1234);
  Exec('taskkill.exe', '/f /im Ext2Mgr.exe', '', SW_HIDE, ewWaitUntilTerminated, ResultCode);

end;

if (CurStep = ssPostInstall) then 
begin
end;

end;


procedure CurUninstallStepChanged (CurUninstallStep: TUninstallStep);
var
  ResultCode: Integer;
  Wnd: HWND;
begin

if (CurUninstallStep = usUninstall) then 
begin

  Wnd := FindWindowByWindowName('Ext2 Volume Manager');
  if Wnd <> 0 then
    SendMessage(Wnd, $1402, 0, $1234);
  Exec('taskkill.exe', '/f /im Ext2Mgr.exe', '', SW_HIDE, ewWaitUntilTerminated, ResultCode);

  Exec(ExpandConstant('{app}\DrvRemover.exe'), 'yes', '', SW_HIDE, ewWaitUntilTerminated, ResultCode);

end;


if (CurUninstallStep = usPostUninstall) then
begin

  RemoveService('Ext2Fsd');
  DelTree(ExpandConstant('{app}'), True, True, True);

end;

end;